<?php

/**
 *
 * coWiki - includes/cowiki/class/dao/expression/class.InExpression.php
 *
 * $Id: class.InExpression.php,v 1.4 2003/09/10 04:49:09 kschroed Exp $
 *
 * This file is part of coWiki. coWiki is free software under the terms of
 * the GNU General Public License (GPL). Read the LICENSE file. If you did
 * not receive a copy of the license and are not able to obtain it through
 * the internet, please send a note to <cowiki-license@develnet.org> so we
 * can mail you a copy immediately.
 *
 * @package     dao
 * @subpackage  expression
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @copyright   (C) Daniel T. Gorski, {@link http://www.develnet.org}
 * @license     http://www.gnu.org/licenses/gpl.html
 * @version     $Revision: 1.4 $
 *
 */

/**
 * coWiki - In expression class
 *
 * @package     dao
 * @subpackage  expression
 * @access      public
 *
 * @author      Daniel T. Gorski, <daniel.gorski@develnet.org>
 * @since       coWiki 0.3.0
 *
 * @todo        [D11N]  Complete documentation
 */
class InExpression extends AbstractSimpleExpression {

    protected
        $sProp   = null,
        $aValues = null;

    /**
     * Class constructor
     *
     * @access  public
     * @param   string
     * @param   array
     * @return  void
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     */
    public function __construct($sProp, $aValues) {
        $this->sProp   = $sProp;
        $this->aValues = $aValues;
    }

    /**
     * To sql string
     *
     * @access  public
     * @return  mixed
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     *
     * @todo    [D11N]  Check description
     */
    public function toSqlString() {
        $sStr = '';

        for ($i=0, $n=sizeof($this->aValues); $i<$n; $i++) {
            $sStr .= '\'' . $this->aValues[$i] . '\'';

            if ($i < $n-1) {
                $sStr .= ', ';
            }
        }

        if ($sStr == '') {
            return '';
        }

        return  $this->sProp . ' IN (' . $sStr . ')';
    }

    /**
     * Get operator
     *
     * @access  public
     * @return  mixed
     *
     * @author  Daniel T. Gorski, <daniel.gorski@develnet.org>
     * @since   coWiki 0.3.0
     *
     * @todo    [D11N]  Check description
     * @todo    [D11N]  Check return type
     */
    public function getOperator() {
        return '';
    }

} // of class

?>
